﻿// 监听来自content-script的消息
// chrome.runtime.onMessage.addListener(function(request, sender, sendResponse)
// {
// 	console.log('收到来自content-script的消息：');
// 	console.log(request, sender, sendResponse);
// 	sendResponse('我是后台，我已收到你的消息：' + JSON.stringify(request));
// });

// console.log("Ok");

// chrome.contextMenus.create({
// 	type: 'normal', 
// 	title: '将图片保存至 溜云库(&Z)', 
// 	contexts: ['all'], 
// onclick: function (res) {

// 	var img_normal = [];
// 	console.log(res);
// console.log(res.srcUrl);

// console.log(img_normal);

// img_normal.push({
// 		"Name": '',
// 		"Url": res.srcUrl
// 	})

// console.log(JSON.stringify(img_normal));

// chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
// 	// console.log(tabs);
// 	// console.log(res.srcUrl);
// 	window.jQuery.ajax({
// 	    method:"POST",
// 	    url: "http://localhost:36366",
// 	    // dataType: "json",
// 	    data: {
// 	        data:JSON.stringify(img_normal)
// 	    }
// 	}).always(function (result) {
// 		// console.log(result);
// 	    if (result.status == 0) {
// 	        openLyk();
// 	    }
// 	})

// });

// }, // 单击时触发的方法
// });

chrome.contextMenus.create({
	contexts: ["all"],
	id: 'background_img',
	title: '将图片保存至 溜云库(&Z)',
});



chrome.contextMenus.onClicked.addListener(function onContextMenu(info, tab) {

	chrome.tabs.sendMessage(tab.id, '', function onMessageResponse(msg) {
		// console.log(msg);
		if (!msg || !msg.src) return;

		var Right_click_data = {
			mainUrl: msg.pageUrl,
			mainTitle: msg.pageTitle,
			imginfos: [{
				infoAlt: msg.metaAlt,
				infoTitle: msg.metaTitle,
				infoUrl: msg.src,
				libid: msg.libid,
			}]
		};


		// console.log(Right_click_data);


		window.jQuery.ajax({
			method: "POST",
			url: "http://localhost:36366",
			// dataType: "json",
			data: {
				data: JSON.stringify(Right_click_data)
			}
		}).always(function (result) {
			// console.log(result);
			if (result.status == 0) {
				openLyk();
			}else{
				// sendResponse('drop_data');
			}
		});  


	});


});


chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {

	if (request.message == 'updateContextMenu') {

		if (request.type === "image") {
			chrome.contextMenus.update('background_img', {
				visible: true,
				contexts: ["all"],
				title: '将图片保存至 溜云库(&Z)',
			});
		} else {
			chrome.contextMenus.update('background_img', {
				visible: false,
				contexts: ["all"],
				title: '将图片保存至 溜云库(&Z)',
			});
		}
	}
	return true;
});

function convertSrc(src) {
	if (src.indexOf("data:image") > -1) return src;
	if (cacheRules && cacheRules.rules) {
		for (let i = 0; i < cacheRules.rules.length; i++) {
			try {
				const rule = cacheRules.rules[i];
				var srcPattern = rule.srcPattern;
				var replaceRule = rule.replaceRule;
				var reg = RegExp(srcPattern);
				if (reg.test(src)) {
					var newSrc;
					var script = replaceRule.replace("'@'", 'src');
					eval(`newSrc = ${script}`);
					// console.log(`${rule.site} > ${newSrc}`);
					return newSrc;
				}
			} catch (err) {
				return src;
			}
		}
	}
	return src;
}


chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	if (request.action == "img_obj") {
		// 这里拿到内注js获取到的当前页面全部img图片
		// console.log(request.data);

		chrome.tabs.query({
			active: true,
			currentWindow: true
		}, function (tabs) {
			var tab = tabs[0];

			window.jQuery.ajax({
				method: "POST",
				url: "http://localhost:36366",
				// dataType: "json",
				data: {
					data: JSON.stringify(request.data)
				}
			}).always(function (result) {
				// console.log(result);
				if (result.status == 0) {
					openLyk();
				}else{
					// sendResponse('drop_data');
				}
			})


		});
	}
	return true;
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	// console.log(request.action);
	if (request.action == "img_right") {
		// 这里拿到用户在页面使用alt+鼠标右键获取的图片信息
		// console.log(request.data);
		chrome.tabs.query({
			active: true,
			currentWindow: true
		}, function (tabs) {
			var tab = tabs[0];
			window.jQuery.ajax({
				method: "POST",
				url: "http://localhost:36366",
				// dataType: "json",
				data: {
					data: JSON.stringify(request.data)
				}
			}).always(function (result) {
				if (result.status == 0) {
					// openLyk();
				}
			})
		});
	}

	if (request.action == "drop_data") {
		// 
		// console.log(JSON.stringify(request.data));
		// console.log(request.data);
		

		chrome.tabs.query({
			active: true,
			currentWindow: true
		}, function (tabs) {
			var tab = tabs[0];
			window.jQuery.ajax({
				method: "POST",
				url: "http://localhost:36366",
				dataType: "json",
				data: {
					data: JSON.stringify(request.data)
				}
			}).always(function (result) {
				// console.log(result);
				if (result.status == 0) {
					openLyk();
				}else{
					// sendResponse('drop_data');
				}
			})
		});

		
	}

	return true;
});



function openLyk() {
	chrome.tabs.query({
		active: true,
		currentWindow: true
	}, function (tabs) {
		chrome.tabs.sendMessage(tabs[0].id, {
			action: "open-not-opened-modal"
		}, function (response) {});
	});
};